import * as PIXI from 'pixi.js';
import 'pixi-sound';
const GameSongs = [
	'1.chill.mp3',
	'2.fun.mp3',
	'3.mystery-fun2.mp3',
	'4.dark-epith-game-2.mp3',
	'5.dark-synth.mp3'
];

class AudioService{
	
	constructor() {
		this.player = '';
		this.loadQueue();
	}

	loadQueue() {
		GameSongs.forEach((songName, index) => this.add(''+(index+1), '/files/assets/songs/' + songName));
	}

	add(songName, songURL) {
		PIXI.sound.add(songName, songURL);
	}
	play(song, opts) {
		PIXI.sound.play(song, opts);
	}

	stop() {
		PIXI.sound.stop();
	}

	loop(song, cue) {

	}

	transitionTo(song, cue) {

	}
}

export default new AudioService();